--! @file
--
--! @brief Address decode logic for ipbus fabric. Given an address it returns which slave is addressed.
--
--! @details
--! This file has been AUTOGENERATED from the address table - do not hand edit
--!
--! We assume the synthesis tool is clever enough to recognise 
--! exclusive conditions in the if statement.
--
--! @author Dave Newbold
--! @date February 2011

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use ieee.numeric_std.all;
use work.ipbus.all;

package ipbus_addr_decode is

  function ipbus_addr_sel(signal addr : in std_logic_vector(31 downto 0)) return integer;

end ipbus_addr_decode;

package body ipbus_addr_decode is

  function ipbus_addr_sel(signal addr : in std_logic_vector(31 downto 0)) return integer is
    variable sel : integer;
  begin

		if    std_match(addr, "----------------000---001-------") then
			sel := 0; -- scshiftreg / base 00000080 / mask 0000007f
                        
		elsif std_match(addr, "----------------000---010-------") then
			sel := 1;  -- rshiftreg / base 00000100 / mask 0000007f
                                   
                elsif std_match(addr, "----------------000---110-------") then
			sel := 2; -- triggerctrl / base 00000300 / mask 000007f
                        
                elsif std_match(addr, "----------------001-------------") then                  
			sel := 3;    -- adcData / base 00002000 / mask 00000fff
                        
                elsif std_match(addr, "----------------010-------------") then                  
			sel := 4;    -- adcCtrl / base 00004000 / mask 00000fff

		elsif std_match(addr, "----------------011-------------") then
			sel := 5; --trigCounters/ base 00006000 / mask 00000fff

		elsif std_match(addr, "----------------100-------------") then
			sel := 6; -- expansionIO/ base 00008000 / mask 00000fff
                        
		elsif std_match(addr, "----------------101-------------") then
			sel := 7; --        i2c / base 0000A000 / mask 00000fff                                                
                                  
		elsif std_match(addr, "----------------000---000-------") then
			sel := 8; -- firmwareid / base 00000000 / mask 00000000 
		else
			sel := 99;
		end if;
		return sel;
	end ipbus_addr_sel;
 
end ipbus_addr_decode;
